// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


const EDITOR_STYLE = "font-size: 12px; font-family: 'Lucida Sans', 'Lucida Sans Unicode', 'Lucida Grande', sans-serif, Arial;";

const flockIHTML2XHTML              = Components.interfaces.flockIHTML2XHTML;
const HTML2XHTML_CONTRACTID         = "@flock.com/html2xhtml;1";

var currentFile;
var gHasChanged = false;
var gViewSource = false;
var gOverrideParagraphBehavior = true;
var gNSHTMLEditor = null;
var gNSEditor = null;


function getHoursMinutes() {
    var time = new Date();
    var minutes = time.getMinutes();
    var hours = time.getHours();
    if (hours < 10)
        hours = "0" + hours.toString();
    if (minutes < 10)
        minutes = "0" + minutes.toString();

    return hours+':'+minutes;
}

///////////////////////////////
// load/close functions
///////////////////////////////

// Observe changes on the datasource
var blogEditorMenuRdfObserver = {
    onAssert            : function(ds, source, predicate, target){
                              if (flock.blog.service.recentIsEmpty()){
                                  $('blogEmptyMenuItem').setAttribute('hidden', 'false');
                              }
                              else {
                                  $('blogEmptyMenuItem').setAttribute('hidden', 'true');
                              }
                          },
    onUnassert          : function(ds, source, predicate, target){
                              if (flock.blog.service.recentIsEmpty()){
                                  $('blogEmptyMenuItem').setAttribute('hidden', 'false');
                              }
                              else {
                                  $('blogEmptyMenuItem').setAttribute('hidden', 'true');
                              }
                          },
    onChange            : function(ds, source, predicate, oldTarget, newTarget){
                              if (flock.blog.service.recentIsEmpty()){
                                  $('blogEmptyMenuItem').setAttribute('hidden', 'false');
                              }
                              else {
                                  $('blogEmptyMenuItem').setAttribute('hidden', 'true');
                              }
                          },
    onMove              : function(ds, oldSource, newSource, predicate, target){},
    onBeginUpdateBatch  : function(ds){},
    onEndUpdateBatch    : function(ds){}
}

function onLoad_blogMenu () {
    var controller = new CommandController();
    controller.cmd_flock_blogBlogThis = flock_blogBlogThisCommand;
    controller.cmd_flock_blogNewPost = flock_blogNewPostCommand;
    controller.cmd_flock_blogOpenPost = flock_blogOpenPostCommand;

    window.controllers.appendController(controller);
}

editorOnload = function() {
  var params;
    
  if(window.arguments && window.arguments.length)
    params  = window.arguments[0];
  if (params.file)
    currentFile = params.file;
  else if (params.content != "") {
    setContent(params.content);
    gHasChanged = true;
  }

  // Update the "recent" menu when needed
  if (flock.blog.service.recentIsEmpty())
    $('blogEmptyMenuItem').setAttribute('hidden', 'false');
  else
    $('blogEmptyMenuItem').setAttribute('hidden', 'true');
  flock.blog.service.AddObserver(blogEditorMenuRdfObserver);

  // Remove unwanted entries in "help"
  $('helpReleaseNotes').setAttribute("hidden", "true");

  // Initialize the content (if it was "open" file") 
  if (currentFile) {
    dump("Blog: loading the file...\n");
    try {
      var theHtml = FileToString(currentFile);
      var theTitle = theHtml.substring(0, theHtml.indexOf('\n'));
      theTitle = theTitle.replace(/<h1>/, '').replace(/<\/h1>/, '');
      $("flock-blog-title").value = theTitle;
      var theBody = theHtml.substring(theHtml.indexOf('\n')+1, theHtml.length);
      setContent(theBody);
      gHasChanged = false;
    }
    catch(e) {
      var strbundle = document.getElementById("editorStringBundle");
      var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                .getService(Components.interfaces.nsIPromptService);
      var msg = strbundle.getString("flock.blog.loading.error.message");
      if (e.name == "NS_ERROR_FILE_NOT_FOUND")
        msg = msg + strbundle.getString("flock.blog.loading.error.fileNotFound");
      else
        msg = msg + e.name;
      prompts.alert(window, strbundle.getString("flock.blog.loading.error"), msg);
    }
  }

  flock_blogEditorSetTitle();
  window.document.commandDispatcher.updateCommands('focus');

  initMidasEditor();

  flock_blogEditorSetupEditorCommands();
  try { $("flock-blog-title").select(); } catch(e) { }

  gNSHTMLEditor.addInsertionListener(InsertionListener);
  dump(getXHtml());
  if (getXHtml() != "<br />\n")
    gNSHTMLEditor.endOfDocument();

  // Setup an account if needed
  if(flock.blog.service.accountCount() == 0)
    flock_blogOpenWizard();
};

var InsertionListener = {
    notifyOfInsertion: function (mimeType , contentSourceURL, sourceDocument ,
        willDeleteSelection , docFragment , contentStartNode , contentStartOffset , 
        contentEndNode , contentEndOffset , insertionPointNode , insertionPointOffset , 
        continueWithInsertion ) 
    {
      try {
        this.mInsertionPointNode = insertionPointNode.value;
        this.mInsertionPointOffset = insertionPointOffset.value;

        var fragment = docFragment.value;
        var src = fragment.firstChild.getAttribute("src");
        dump(src);
        if (fragment.firstChild.nodeName=="IMG" && src.match(/^file:\/\//) && flock.photo.util.isAPhoto(src)) {
            this.mSrc = src;
            window.setTimeout(InsertionListener.tryInsert, 0);
        }
        if (fragment.firstChild.nodeName=="A") {
            dump("Link insertion\n");
            dump(this.mSrc+"\n");
            continueWithInsertion.value = true;
        }
        else {
            continueWithInsertion.value = true;
        }
      }
      catch(e) {
        continueWithInsertion.value = true;
      }
    },
    tryInsert: function() {
        var url = InsertionListener.mSrc;
        var rval = { value: "", }
        var uploadsvc = flock.photouploader.service;
        var utils = flock.photo.util;
        var createPhotoUploadListener = {
            url: url,
            onCreatePhotoUpload: function(aPhotoUpload) {
                utils.launchSinglePhotoUpload(aPhotoUpload, rval);
                gNSHTMLEditor.insertHTMLWithContext(rval.value, "", "", "", null, 
                    InsertionListener.mInsertionPointNode, InsertionListener.mInsertionPointOffset, false);
            }
        }
        uploadsvc.createPhotoUpload(createPhotoUploadListener, url);
    },
}

function flock_blogEditorCanClose() {
    var result;
    var strbundle=document.getElementById("editorStringBundle");
    var saveentry=strbundle.getString("flock.blog.post.save.entry");
    var doyouwanttosave=strbundle.getString("flock.blog.post.save.draft");

    if(gHasChanged) {
	    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    	var flags=promptService.BUTTON_TITLE_SAVE * promptService.BUTTON_POS_0 +
    	    promptService.BUTTON_TITLE_CANCEL * promptService.BUTTON_POS_1 +
    	    promptService.BUTTON_TITLE_DONT_SAVE * promptService.BUTTON_POS_2;
	
    	result = promptService.confirmEx(window, saveentry, doyouwanttosave, flags,
					 null, null, null, null, {});
	
    	switch (result){
    	case 0: // Save
    	    flock_blogEditorSavePostCommand.exec();	    
    	    return true;
    	case 1: // Cancel
    	    return false;
    	case 2: // Don't save
    	    return true;
    	}
    } else {
        return true;
    }  
}

editorOnclose = function() {
    var close = flock_blogEditorCanClose();
    if (close) {
        window.controllers.removeController(gBlogEditCommandController);
        flock.blog.service.RemoveObserver(blogEditorMenuRdfObserver);
    }
    // XXX andy: calling the shelf stuff manually here, too
    onUnload_shelf();

    try { gNSHTMLEditor.removeInsertionListener(InsertionListener); }
    catch(e) { } 

    return close;
};


// Functions related to the Midas editor /*{{{*/
function execCommand(action){
  var strbundle = document.getElementById("editorStringBundle");
  var doc = $('edit').contentWindow.document;
  var sel = $('edit').contentWindow.getSelection();
  var win = $('edit').contentWindow;
  switch(action){
    case "insertimage":
      var szURL = prompt(strbundle.getString("flock.blog.loading.enterImageURL"), "http://");
      if ((szURL != null) && (szURL != "")) {
          $('edit').contentWindow.document.execCommand("InsertImage", false, szURL);
      }
      break;
    default:
      $('edit').contentWindow.document.execCommand(action, false, null);
  }
}

function onClickInEditor(event) {
  if ((event.rangeParent.nodeName == "BODY") && (getXHtml() != "<br />\n"))
    gNSHTMLEditor.endOfDocument();
}

// True if the node is in body, or in a formatting node in body
function isInBody(aNode) {
    if ((aNode.parentNode.nodeName=="I") || (aNode.parentNode.nodeName=="B"))
        return isInBody(aNode.parentNode);
    if (aNode.parentNode.nodeName=="BODY")
        return true;
    return false;
}

function initMidasEditor(){
    $('edit').contentWindow.document.designMode = "on";
    $('edit').contentWindow.document.execCommand("styleWithCSS", false, false);
    $('edit').contentWindow.document.execCommand("undo", false, null);
    $('edit').contentWindow.document.body.setAttribute("style", EDITOR_STYLE);

    //setup paragraph breaking behavior - this only creates new paragraphs if
    //you are already in another paragraph - add a <p> to test
    gNSEditor = $('edit').boxObject.docShell.QueryInterface(Components.interfaces.nsIEditorDocShell);
    gNSHTMLEditor = gNSEditor.editor.QueryInterface(Components.interfaces.nsIHTMLEditor);
    gNSHTMLEditor.returnInParagraphCreatesNewParagraph = true;

    var keyListener = function(aEvent) {
        if(aEvent.keyCode==aEvent.DOM_VK_RETURN) {
            dump(aEvent.keyCode + "\n");
            var sel = $('edit').contentWindow.getSelection();
            
            if(isInBody(sel.anchorNode)) {
                if(gOverrideParagraphBehavior) {
                    //insert the paragraph
                    gNSHTMLEditor.setParagraphFormat("p");
                    gNSHTMLEditor.insertHTML("<p><!-- PProtector --></p>");
                    aEvent.preventDefault();
                }
            }
        }
    }
    $('edit').addEventListener('keypress', keyListener, true);

}

var flock_blogBold =
{
    isEnabled: function() {
        return true;
    },
    exec: function() {
        execCommand('bold');
        return;
    }
}

var flock_blogItalic =
{
    isEnabled: function() {
        return true;
    },
    exec: function() {
        execCommand('italic');
        return;
    }
}

var flock_blogIndent =
{
    isEnabled: function() {
        return true;
    },
    exec: function() {
        execCommand('indent');
        return;
    }
}

var flock_blogOutdent =
{
    isEnabled: function() {
        return true;
    },
    exec: function() {
        execCommand('outdent');
        return;
    }
}

var flock_blogLink =
{
  isEnabled: function() {
    var sel = $('edit').contentWindow.getSelection();
    var node = gNSHTMLEditor.selection.getRangeAt(0).cloneContents().firstChild;
    var anchorElement = gNSHTMLEditor.getElementOrParentByTagName("href", gNSHTMLEditor.selection.anchorNode);

    if (sel != "") // Text is selection
      return true;
    if (node)
      if (node.nodeName == "IMG") // An image is selected
        return true;
    if (anchorElement) // No selection, but the cursor is on a link
      return true;
    
    return false;
  },
  exec: function() {
    var url = "";
    // GPL Code borrowed (and modified) from EdLinkProps.js on Mozilla.org
    ///////////////////////////////////////////////////////////////////////
    // NOTE: Use "href" instead of "a" to distinguish from Named Anchor
    // The returned node is has an "a" tagName
    var tagName = "href";
    // See if we have a single selected image
    var imageElement = gNSHTMLEditor.getSelectedElement("img");

    // Get an anchor element if caret or
    //   entire selection is within the link.
    anchorElement = gNSHTMLEditor.getSelectedElement(tagName);

    if (anchorElement)
    {
      dump("We got an anchorElement\n");
      // Select the entire link
      gNSHTMLEditor.selectElement(anchorElement);
    }
    else
    {
        // If selection starts in a link, but extends beyond it,
        //   the user probably wants to extend existing link to new selection,
        //   so check if either end of selection is within a link
        // POTENTIAL PROBLEM: This prevents user from selecting text in an existing
        //   link and making 2 links. 
        // Note that this isn't a problem with images, handled above
  
        anchorElement = gNSHTMLEditor.getElementOrParentByTagName("href", gNSHTMLEditor.selection.anchorNode);
        if (!anchorElement)
          anchorElement = gNSHTMLEditor.getElementOrParentByTagName("href", gNSHTMLEditor.selection.focusNode);

        if (anchorElement)
        {
          // But clone it for reinserting/merging around existing
          //   link that only partially overlaps the selection
          anchorElement = anchorElement.cloneNode(false);
          //insertNew = true;
          replaceExistingLink = true;
        }
    }

    var selectedText;
    if (!imageElement)
    {
      // We get here if selection is exactly around a link node
      var node = gNSHTMLEditor.selection.getRangeAt(0).cloneContents().firstChild;
      if (node.nodeName == "A")
        selectedText  = node.getAttribute("HREF");
      if ((!selectedText) && (anchorElement))
      {
        // No text, look for first image in the selection
        var children = anchorElement.childNodes;
        if (children)
        {
          for(var i=0; i < children.length; i++) 
          {
            var nodeName = children.item(i).nodeName.toLowerCase();
            if (nodeName == "img")
            {
              imageElement = children.item(i);
              break;
            }
          }
        }
      }
    }
    // Set "caption" for link source and the source text or image URL
    if (imageElement) {
      if (imageElement.parentNode.nodeName == "A")
        url = imageElement.parentNode.href;
    } else if (selectedText) 
      url = selectedText; 


    var strbundle = document.getElementById("editorStringBundle");
//    var node = gNSHTMLEditor.selection.getRangeAt(0).cloneContents().firstChild;
//    var url = "";
//    dump("Nodename: "+node.nodeName+"\n");
//    dump("parent Nodename: "+node.parentNode.nodeName+"\n");
//    if (node.nodeName == "A")
//      url = node.getAttribute("HREF");
//    else if ((node.nodeName == "IMG") && (node.parentNode.nodeName == "A"))
//      url = node.parentNode.getAttribute("HREF");
    var szURL = prompt(strbundle.getString("flock.blog.loading.enterURL"), url);
    if ((szURL != null) && (szURL != "")) {
      $('edit').contentWindow.document.execCommand("CreateLink", false, szURL);
    }
    return;
  }
}

var flock_blogUnlink =
{
  isEnabled: function() {
    var sel = $('edit').contentWindow.getSelection();
    var node = gNSHTMLEditor.selection.getRangeAt(0).cloneContents().firstChild;
    var anchorElement = gNSHTMLEditor.getElementOrParentByTagName("href", gNSHTMLEditor.selection.anchorNode);

    if (sel != "")
      return true;
    if (node)
      if (node.nodeName == "IMG")
        return true;
    if (anchorElement) // No selection, but the cursor is on a link
      return true;

      return false;
    },
  exec: function() {
    var anchorElement = gNSHTMLEditor.getElementOrParentByTagName("href", gNSHTMLEditor.selection.anchorNode);

    if (anchorElement)
    {
      // Select the entire link
      gNSHTMLEditor.selectElement(anchorElement);
    }
    execCommand('unlink');
    return;
  }
}


// Switch tab
function viewsource(source)
{
  var html;
  if (gViewSource == source) return;
  if (source) {
    $('editordeck').selectedIndex = 1;
    $("editorToolbar").setAttribute('hidden', true);
    $('editsource').value = getXHtml();
    $('editsource').focus();
  } else {
    $('editordeck').selectedIndex = 0;
    $("editorToolbar").removeAttribute('hidden');;
    html = $('editsource').value;
    setContent(html);
    $('edit').contentWindow.focus();
  }
  gViewSource = source;
}

function setContent(aContent){
    aContent = aContent.replace(/\n/g, '');
    $('edit').contentWindow.document.body.innerHTML = aContent;
    $('edit').contentWindow.document.body.setAttribute("style", EDITOR_STYLE); 
}

function getXHtml(){
    //dump($('edit').contentWindow.document.body.innerHTML);

    var serializer = new XMLSerializer();
    var xml = serializer.serializeToString($('edit').contentWindow.document.body);
    // Remove <HTML>, <HEAD> and <BODY>
    //xml = xml.replace(/<BODY\sstyle\="[\w\d\s\:\;\,\']+">/, '');
    xml = xml.replace(/<BODY[^>]*>/, '');
    xml = xml.replace(/<\/BODY>/, '');
    xml = xml.replace(/\s_moz_dirty="\w*"/g, '');
    xml = xml.replace(/\stype="_moz"/g, '');
    xml = xml.replace(/\s_moz_[a-zA-Z_]+="\w*"/g, '');
    xml = xml.replace(/<!-- PProtector -->/g, '');
    // Add a space before /> (IE5.5, Wordpress.com don't like it)
    xml = xml.replace(/\"\/>/g, '" />');
    xml = xml.replace(/\'\/>/g, "' />");
    // Small cap and pretty print
    xml = xml.replace(/<BR\/>/g, '<br />\n');
    xml = xml.replace(/<B>/g, '<strong>');
    xml = xml.replace(/<STRONG>/g, '<strong>');
    xml = xml.replace(/<\/B>/g, '</strong>');
    xml = xml.replace(/<\/STRONG>/g, '</strong>');
    xml = xml.replace(/<I>/g, '<i>');
    xml = xml.replace(/<\/I>/g, '</i>');
    xml = xml.replace(/<STRIKE>/g, '<strike>');
    xml = xml.replace(/<\/STRIKE>/g, '</strike>');
    xml = xml.replace(/<A/g, '<a');
    xml = xml.replace(/<\/A/g, '</a');
    xml = xml.replace(/<SPAN/g, '<span');
    xml = xml.replace(/<\/SPAN/g, '</span');
    xml = xml.replace(/<P/g, '<p');
    xml = xml.replace(/<\/P>/g, '<\/p>\n\n');
    xml = xml.replace(/<LI>/g, '<li>');
    xml = xml.replace(/<\/LI>/g, '<\/li>\n');
    xml = xml.replace(/<UL>/g, '<ul>\n');
    xml = xml.replace(/<\/UL>/g, '<\/ul>\n');
    xml = xml.replace(/<OL>/g, '<ol>');
    xml = xml.replace(/<\/OL>/g, '<\/ol>\n');
    xml = xml.replace(/<BLOCKQUOTE/g, '<blockquote');
    xml = xml.replace(/<\/BLOCKQUOTE/g, '</blockquote');
    xml = xml.replace(/<CITE/g, '<cite');
    xml = xml.replace(/<\/CITE/g, '</cite');
    xml = xml.replace(/<IMG/g, '<img');
    //dump(xml);
    return xml;
}

function flock_blogEditorSetTitle() {
    var strbundle = document.getElementById("editorStringBundle");
    var title = strbundle.getString("flock.blog.settitle.message") + " " + $("flock-blog-title").value;
    window.title = title;
    window.document.title = title;
}

onTitleKeypress = function(aEvent) {
    switch(aEvent.keyCode) {
        case aEvent.DOM_VK_TAB:
            if (gViewSource)
                $('editsource').focus();
            else
                $('edit').contentWindow.focus();
            aEvent.preventDefault();
        break;
        default:
            gHasChanged = true;
            window.document.commandDispatcher.updateCommands('focus');
    }
};

function onSourceKeypress(e){
    gHasChanged = true;
    window.document.commandDispatcher.updateCommands('focus');
}

function onEditorKeypress(e){
    gHasChanged = true;
    window.document.commandDispatcher.updateCommands('focus');
}

var sourceDropObserver = {
  onDragOver: function (event, flavor, session) { },
  onDrop: function (evt, dropData, asession) {
    dump("++++++++ GOT IT!! ++++++++++++++\n");
    dump("++"+$('editsource').selectionEnd+"\n");
    var start = $('editsource').value.substr(0, $('editsource').selectionEnd);
    var end = $('editsource').value.substr($('editsource').selectionEnd);
    $('editsource').value = start + dropData.data + end;
  },

  getSupportedFlavours: function(){
    flavors = new FlavourSet();
    flavors.appendFlavour('text/html');
    return flavors;
                      }
}

///////////////////////////////
// Commands 
///////////////////////////////

var gBlogEditCommandController = null;

function blogOpenFile(aEntry) {/*{{{*/
    try {
       if (flock_blogEditorCanClose()) {
           currentFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
           currentFile.initWithPath(aEntry.getAttribute("filename"));

           var theHtml = FileToString(currentFile);
           var theTitle = theHtml.substring(0, theHtml.indexOf('\n'));
           theTitle = theTitle.replace(/<h1>/, '').replace(/<\/h1>/, '');
           $("flock-blog-title").value = theTitle;
           var theBody = theHtml.substring(theHtml.indexOf('\n')+1, theHtml.length);
           setContent(theBody);
           flock_blogEditorSetTitle();
           gHasChanged = false;
           window.document.commandDispatcher.updateCommands('focus');
           // flock.blog.settings.addRecent(filePick.fileURL);
       }
          
    }
    catch(e) {
        dump(e + " " + e.lineNumber + " " + e.fileName);
    }
}/*}}}*/

var flock_blogEditorOpenPostCommand = {/*{{{*/
    isEnabled: function() {
        return true;
    },
    exec: function() {
        try {
           if (flock_blogEditorCanClose()) {
               var strbundle = document.getElementById("editorStringBundle");
               var filePick = PromptToOpenFile();
               if (filePick) {
                   viewsource(false);
                   currentFile = filePick.file;
                   var theHtml = FileToString(currentFile);
                   var theTitle = theHtml.substring(0, theHtml.indexOf('\n'));
                   theTitle = theTitle.replace(/<h1>/, '').replace(/<\/h1>/, '');
                   $("flock-blog-title").value = theTitle;
                   var theBody = theHtml.substring(theHtml.indexOf('\n')+1, theHtml.length);
                   setContent(theBody);
                   flock_blogEditorSetTitle();
                   gHasChanged = false;
                   window.document.commandDispatcher.updateCommands('focus');
                   flock.blog.service.addRecent(filePick.fileURL.fileName.replace('.html',''),
                          filePick.fileURL.filePath);
                   $('save-status').setAttribute('label',
                      strbundle.getString("flock.blog.post.notsaved")); 
               }
           }
            
        }
        catch(e) {
            dump(e + " " + e.lineNumber + " " + e.fileName);
        }
    }
}/*}}}*/

function defaultFile(aDirectory, aTitle){/*{{{*/
    var title = aTitle.replace(/[^a-zA-Z0-9]+/g, '-'); 
    var newFile = aDirectory.clone();
    newFile.append(title+".html");

    var i=1;
    while (newFile.exists()) {
        newFile = aDirectory.clone();
        newFile.append(title+" ("+i+").html");
        i++;
    }
    return newFile;
}/*}}}*/

var flock_blogEditorSavePostCommand = {/*{{{*/
    isEnabled: function() {
        return gHasChanged;
    },
    exec: function() {
        try {
            var directoryNotSet = !(flock.blog.locationPrefIsSet());
            if (!currentFile) {
                var defaultDir = flock.blog.getSaveLocation();
                currentFile = defaultFile(defaultDir, $('flock-blog-title').value);
            }
            dump("Saving the post to: "+currentFile.path+"\n");
            // Get the xhtml source (from the editor or the source pane)
            var html;        
            if ($('editordeck').selectedIndex == 0)
              html = getXHtml();
            else
              html = $('editsource').value;
            result = SaveDocument(html, $("flock-blog-title").value, currentFile, false);
            if (result) { 
                var strbundle = document.getElementById("editorStringBundle");
                flock_blogEditorSetTitle();
                gHasChanged = false;
                window.document.commandDispatcher.updateCommands('focus');
                flock.blog.service.addRecent(currentFile.leafName.replace('.html',''),
                          currentFile.path);
                $('save-status').setAttribute('label', strbundle.getString("flock.blog.post.saved")
                                                       + ' '+getHoursMinutes());
                if (directoryNotSet) {
                    var msg = strbundle.getString("flock.blog.post.save.message") + "\n\n";
                    msg = msg + currentFile.path+"\n\n";
                    msg = msg + strbundle.getString("flock.blog.post.save.message.part2") + "\n\n";
                    msg = msg + strbundle.getString("flock.blog.post.save.message.part3");
                    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService); 
                    promptService.alert(window, 
                        strbundle.getString("flock.blog.post.save.message.title"), msg);
                }
            }
        }
        catch(e) {
            dump(e + " " + e.lineNumber + " " + e.fileName);
        }
    },
}/*}}}*/

var flock_blogEditorSavePostAsCommand = {/*{{{*/
    isEnabled: function() {
        return true;
    },
    exec: function() {
        try {
            // Get the xhtml source (from the editor or the source pane)
            var html;        
            if ($('editordeck').selectedIndex == 0)
              html = getXHtml();
            else
              html = $('editsource').value;

            result = SaveDocument(html, $("flock-blog-title").value, currentFile, true);
            if (result) {
                var strbundle = document.getElementById("editorStringBundle");
                flock_blogEditorSetTitle();
                gHasChanged = false;
                window.document.commandDispatcher.updateCommands('focus');
                currentFile = result;
                flock.blog.service.addRecent(currentFile.leafName.replace('.html',''),
                          currentFile.path);
               $('save-status').setAttribute('label', 
                                strbundle.getString("flock.blog.post.save.message.title")
                                + ' '+getHoursMinutes());
            }
        }
        catch(e) {
            dump(e + " " + e.lineNumber + " " + e.fileName);
        }
    },
}/*}}}*/

var flock_blogEditorPublishPostCommand = {/*{{{*/
    isEnabled: function() {
        return true;
    },
    exec: function() {
        // Save the post if needed
        if (gHasChanged)
           flock_blogEditorSavePostCommand.exec();

        // Setup an account if needed
        if(flock.blog.service.accountCount() == 0)
            flock_blogOpenWizard();

        // Get the xhtml source (from the editor or the source pane)
        var html;        
        if ($('editordeck').selectedIndex == 0)
          html = getXHtml();
        else
          html = $('editsource').value;
        // Publish only if an account has been configured
        if(flock.blog.service.accountCount() > 0) {
            var params = {
                title : $("flock-blog-title").value,
                html : html,
                editURI : null
           };
           window.published = false;
           window.permalink = false;
           window.openDialog("blogMetadata.xul", "metadataDialog", "modal,centerscreen", params);

           if (window.published){
               // Open a window showing the post/blog
               if (window.permalink)
                   window.opener.open(window.permalink, "BlogWindow");

               window.controllers.removeController(gBlogEditCommandController);
               flock.blog.service.RemoveObserver(blogEditorMenuRdfObserver);
               window.close();
           }
        }
    },
}/*}}}*/

var flock_blogEditorToggleShelf = {/*{{{*/
    isEnabled: function() {
	if (gShelf)
       	  return !(gShelf.previewMode);
        else
          return false;
    },
    exec: function() {
        gShelf.toggle();
        if ($('shelfMenuItem').getAttribute('checked'))
            $('shelfMenuItem').setAttribute('checked', false);
        else
            $('shelfMenuItem').setAttribute('checked', true);
    },
}/*}}}*/

var flock_blogClose = {/*{{{*/
    isEnabled: function() {
        return true;
    },
    exec: function() {
        if (flock_blogEditorCanClose()) {
            window.controllers.removeController(gBlogEditCommandController);
            flock.blog.service.RemoveObserver(blogEditorMenuRdfObserver);
            window.close();
        }
    },
}/*}}}*/

function flock_blogEditorSetupEditorCommands() {/*{{{*/
    if(gBlogEditCommandController) return;
    gBlogEditCommandController = new CommandController();

    gBlogEditCommandController.cmd_flock_blogPublishPost = flock_blogEditorPublishPostCommand;
    gBlogEditCommandController.cmd_flock_blogNewPost = flock_blogNewPostCommand;
    gBlogEditCommandController.cmd_flock_blogOpenPost = flock_blogEditorOpenPostCommand;
    gBlogEditCommandController.cmd_flock_blogSavePost = flock_blogEditorSavePostCommand;
    gBlogEditCommandController.cmd_flock_blogSavePostAs = flock_blogEditorSavePostAsCommand;
    gBlogEditCommandController.cmd_flock_blogClose = flock_blogClose;
    gBlogEditCommandController.cmd_flock_blogToggleShelf = flock_blogEditorToggleShelf;

    gBlogEditCommandController.cmd_flock_blogBold = flock_blogBold;
    gBlogEditCommandController.cmd_flock_blogItalic = flock_blogItalic;
    gBlogEditCommandController.cmd_flock_blogIndent = flock_blogIndent;
    gBlogEditCommandController.cmd_flock_blogOutdent = flock_blogOutdent;
    gBlogEditCommandController.cmd_flock_blogLink = flock_blogLink;
    gBlogEditCommandController.cmd_flock_blogUnlink = flock_blogUnlink;

    window.controllers.appendController(gBlogEditCommandController);
    window.addEventListener('focus',function () { window.document.commandDispatcher.updateCommands('focus'); },false);
    window.addEventListener('click',function () { window.document.commandDispatcher.updateCommands('click'); },false);
    window.addEventListener('dragdrop',function () { ; },false);
    window.document.commandDispatcher.updateCommands('focus');
    window.focus();
}/*}}}*/

function flock_blogUpdateEditCommands() {/*{{{*/
    flock_blogUpdateCommands($("flock_BlogEditCommands"), gBlogCommandController);
}/*}}}*/

// Code generation and cleanup borrowed from tinyMCE /*{{{*/

const blockRegExp = new RegExp("^(h[1-6]|p|div|address|pre|form|table|li|ol|ul|td|blockquote|center|dl|dir|fieldset|form|noscript|noframes|menu|isindex)$", "i");

getNodeTree = function(node, node_array, type, node_name) { /*{{{*/
	if (typeof(type) == "undefined" || node.nodeType == type && (typeof(node_name) == "undefined" || node.nodeName == node_name))
		node_array[node_array.length] = node;

	if (node.hasChildNodes()) {
		for (var i=0; i<node.childNodes.length; i++)
			getNodeTree(node.childNodes[i], node_array, type, node_name);
	}

	return node_array;
};/*}}}*/

getAbsPosition = function(node) {/*{{{*/
	var pos = new Object();

	pos.absLeft = pos.absTop = 0;

	var parentNode = node;
	while (parentNode) {
		pos.absLeft += parentNode.offsetLeft;
		pos.absTop += parentNode.offsetTop;

		parentNode = parentNode.offsetParent;
	}

	return pos;
};/*}}}*/

isBlockElement = function(node) { /*{{{*/
	return node != null && node.nodeType == 1 && this.blockRegExp.test(node.nodeName);
}; /*}}}*/

getParentBlockElement = function(node) { /*{{{*/
    // Search up the tree for block element
    while (node) {
        if (blockRegExp.test(node.nodeName))
            return node;
        node = node.parentNode;
    }

    return null;
}; /*}}}*/

getParentElement = function(node, names, attrib_name, attrib_value) { /*{{{*/
	if (typeof(names) == "undefined") {
		if (node.nodeType == 1)
			return node;

		// Find parent node that is a element
		while ((node = node.parentNode) != null && node.nodeType != 1) ;

		return node;
	}

	var namesAr = names.split(',');

	if (node == null)
		return null;

	do {
		for (var i=0; i<namesAr.length; i++) {
			if (node.nodeName.toLowerCase() == namesAr[i].toLowerCase() || names == "*") {
				if (typeof(attrib_name) == "undefined")
					return node;
				else if (node.getAttribute(attrib_name)) {
					if (typeof(attrib_value) == "undefined") {
						if (node.getAttribute(attrib_name) != "")
							return node;
					} else if (node.getAttribute(attrib_name) == attrib_value)
						return node;
				}
			}
		}
	} while ((node = node.parentNode) != null);

	return null;
}; /*}}}*/

var selectedElement = null;
selectNode = function(node, collapse, select_text_node, to_start) {
	if (!node)
		return;

	if (typeof(collapse) == "undefined")
		collapse = true;

	if (typeof(select_text_node) == "undefined")
		select_text_node = false;

	if (typeof(to_start) == "undefined")
		to_start = true;

	var sel = $('edit').contentWindow.getSelection();

	if (!sel)
		return;

	var rng = $('edit').contentWindow.document.createRange();

	if (select_text_node) {
		// Find first textnode in tree
		var nodes = getNodeTree(node, new Array(), 3);
		if (nodes.length > 0)
			rng.selectNodeContents(nodes[0]);
		else
			rng.selectNodeContents(node);
	} else
		rng.selectNode(node);

	if (collapse) {
		// Special treatment of textnode collapse
		if (!to_start && node.nodeType == 3) {
			rng.setStart(node, node.nodeValue.length);
			rng.setEnd(node, node.nodeValue.length);
		} else
			rng.collapse(to_start);
	}

	sel.removeAllRanges();
	sel.addRange(rng);

	this.scrollToNode(node);

	// Set selected element
	selectedElement = null;
	if (node.nodeType == 1)
		selectedElement = node;
};

scrollToNode = function(node) { /*{{{*/
	// Scroll to node position
	var pos = getAbsPosition(node);
	var doc = $('edit').contentWindow.document
	var scrollX = doc.body.scrollLeft + doc.documentElement.scrollLeft;
	var scrollY = doc.body.scrollTop + doc.documentElement.scrollTop;
	var height = $('edit').clientHeight;

	// Only scroll if out of visible area
	if (!(pos.absTop > scrollY && pos.absTop < (scrollY - 25 + height)))
		$('edit').contentWindow.scrollTo(pos.absLeft, pos.absTop - height + 25); 
}; /*}}}*/


insertPara = function(e) { /*{{{*/
    // dump("Insert paragraph...\n");
    function isEmpty(para) {
	function isEmptyHTML(html) {
		return html.replace(new RegExp('[ \t\r\n]+', 'g'), '').toLowerCase() == "";
	}

	// Check for images
	if (para.getElementsByTagName("img").length > 0)
		return false;

	// Check for tables
	if (para.getElementsByTagName("table").length > 0)
		return false;

	// Check for HRs
	if (para.getElementsByTagName("hr").length > 0)
		return false;

	// Check all textnodes
	var nodes = getNodeTree(para, new Array(), 3);
	for (var i=0; i<nodes.length; i++) {
		if (!isEmptyHTML(nodes[i].nodeValue))
			return false;
	}

	// No images, no tables, no hrs, no text content then it's empty
	return true;
    }

    var doc = $('edit').contentWindow.document;
    var sel = $('edit').contentWindow.getSelection();
    var win = $('edit').contentWindow;
    var rng = sel.getRangeAt(0);
    var body = doc.body;
    var rootElm = doc.documentElement;
    var self = this;
    var blockName = "P";

    // Setup before range
    var rngBefore = doc.createRange();
    rngBefore.setStart(sel.anchorNode, sel.anchorOffset);
    rngBefore.collapse(true);

    // Setup after range
    var rngAfter = doc.createRange();
    rngAfter.setStart(sel.focusNode, sel.focusOffset);
    rngAfter.collapse(true);

    // Setup start/end points
    var direct = rngBefore.compareBoundaryPoints(rngBefore.START_TO_END, rngAfter) < 0;
    var startNode = direct ? sel.anchorNode : sel.focusNode;
    var startOffset = direct ? sel.anchorOffset : sel.focusOffset;
    var endNode = direct ? sel.focusNode : sel.anchorNode;
    var endOffset = direct ? sel.focusOffset : sel.anchorOffset;

	startNode = startNode.nodeName == "BODY" ? startNode.firstChild : startNode;
	endNode = endNode.nodeName == "BODY" ? endNode.firstChild : endNode;

	// Get block elements
	var startBlock = getParentBlockElement(startNode);
	var endBlock = getParentBlockElement(endNode);

	// Use current block name
	if (startBlock != null) {
		blockName = startBlock.nodeName;

	// Use P instead
	if (blockName == "TD" || blockName == "TABLE" || (blockName == "DIV" && new RegExp('left|right', 'gi').test(startBlock.style.cssFloat)))
		blockName = "P";
	}

	// Within a list use normal behaviour
	if (getParentElement(startBlock, "OL,UL") != null)
		return false;

	// Within a table create new paragraphs
	if ((startBlock != null && startBlock.nodeName == "TABLE") || (endBlock != null && endBlock.nodeName == "TABLE"))
		startBlock = endBlock = null;

	// Setup new paragraphs
	var paraBefore = (startBlock != null && startBlock.nodeName == blockName) ? startBlock.cloneNode(false) : doc.createElement(blockName);
	var paraAfter = (endBlock != null && endBlock.nodeName == blockName) ? endBlock.cloneNode(false) : doc.createElement(blockName);

	// Is header, then force paragraph under
	if (/^(H[1-6])$/.test(blockName))
		paraAfter = doc.createElement("p");

	// Setup chop nodes
	var startChop = startNode;
	var endChop = endNode;

	// Get startChop node
	node = startChop;
	do {
		if (node == body || node.nodeType == 9 || isBlockElement(node))
			break;

		startChop = node;
	} while ((node = node.previousSibling ? node.previousSibling : node.parentNode));

	// Get endChop node
	node = endChop;
	do {
		if (node == body || node.nodeType == 9 || isBlockElement(node))
			break;

		endChop = node;
	} while ((node = node.nextSibling ? node.nextSibling : node.parentNode));

	// Fix when only a image is within the TD
	if (startChop.nodeName == "TD")
		startChop = startChop.firstChild;

	if (endChop.nodeName == "TD")
		endChop = endChop.lastChild;

	// If not in a block element
	if (startBlock == null) {
                //dump("... not in a block element\n");
		// Delete selection
		rng.deleteContents();
		sel.removeAllRanges();

		if (startChop != rootElm && endChop != rootElm) {
			// Insert paragraph before
			rngBefore = rng.cloneRange();

			if (startChop == body)
				rngBefore.setStart(startChop, 0);
			else
				rngBefore.setStartBefore(startChop);

			paraBefore.appendChild(rngBefore.cloneContents());

			// Insert paragraph after
			if (endChop.parentNode.nodeName == blockName)
				endChop = endChop.parentNode;

			// If not after image
			//if (rng.startContainer.nodeName != "BODY" && rng.endContainer.nodeName != "BODY")
				rng.setEndAfter(endChop);

			if (endChop.nodeName != "#text" && endChop.nodeName != "BODY")
				rngBefore.setEndAfter(endChop);

			var contents = rng.cloneContents();
			if (contents.firstChild && (contents.firstChild.nodeName == blockName || contents.firstChild.nodeName == "BODY"))
				paraAfter.innerHTML = contents.firstChild.innerHTML;
			else
				paraAfter.appendChild(contents);

			// Check if it's a empty paragraph
			if (isEmpty(paraBefore))
				paraBefore.innerHTML = "";

			// Check if it's a empty paragraph
			if (isEmpty(paraAfter))
			    paraAfter.innerHTML = "";

			// Delete old contents
			rng.deleteContents();
			rngAfter.deleteContents();
			rngBefore.deleteContents();

			// Insert new paragraphs
			paraAfter.normalize();
			rngBefore.insertNode(paraAfter);
			paraBefore.normalize();
			rngBefore.insertNode(paraBefore);

		} else {
			body.innerHTML = "<" + blockName + ">&nbsp;</" + blockName + "><" + blockName + ">&nbsp;</" + blockName + ">";
			paraAfter = body.childNodes[1];
		}

		selectNode(paraAfter, true, true);

		return true;
	}

	// Place first part within new paragraph
	if (startChop.nodeName == blockName)
		rngBefore.setStart(startChop, 0);
	else
		rngBefore.setStartBefore(startChop);

	rngBefore.setEnd(startNode, startOffset);
	paraBefore.appendChild(rngBefore.cloneContents());

	// Place secound part within new paragraph
	rngAfter.setEndAfter(endChop);
	rngAfter.setStart(endNode, endOffset);
	var contents = rngAfter.cloneContents();

	if (contents.firstChild && contents.firstChild.nodeName == blockName) {
/*		var nodes = contents.firstChild.childNodes;
		for (var i=0; i<nodes.length; i++) {
			//tinyMCE.debug(nodes[i].nodeName);
			if (nodes[i].nodeName != "BODY")
				paraAfter.appendChild(nodes[i]);
		}
*/
		paraAfter.innerHTML = contents.firstChild.innerHTML;
	} else
		paraAfter.appendChild(contents);

	// Check if it's a empty paragraph
	if (isEmpty(paraBefore))
		paraBefore.innerHTML = "&nbsp;";

	// Check if it's a empty paragraph
	if (isEmpty(paraAfter))
		paraAfter.innerHTML = "&nbsp;";

	// Create a range around everything
	var rng = doc.createRange();

	if (!startChop.previousSibling && startChop.parentNode.nodeName.toUpperCase() == blockName) {
		rng.setStartBefore(startChop.parentNode);
	} else {
		if (rngBefore.startContainer.nodeName.toUpperCase() == blockName && rngBefore.startOffset == 0)
			rng.setStartBefore(rngBefore.startContainer);
		else
			rng.setStart(rngBefore.startContainer, rngBefore.startOffset);
	}

	if (!endChop.nextSibling && endChop.parentNode.nodeName.toUpperCase() == blockName)
		rng.setEndAfter(endChop.parentNode);
	else
		rng.setEnd(rngAfter.endContainer, rngAfter.endOffset);

	// Delete all contents and insert new paragraphs
	rng.deleteContents();
	rng.insertNode(paraAfter);
	rng.insertNode(paraBefore);

	// Normalize
	paraAfter.normalize();
	paraBefore.normalize();

	selectNode(paraAfter, true, true);

	return true;
};/*}}}*/

/*}}}*/

function doSpellCheck() {
  var args = new Array();
  args[0] = $('edit').contentWindow.document.firstChild.nextSibling;//html enclosure
  var params = "chrome,close,titlebar,resizable";
  params += ",modal";

  window.openDialog("chrome://spellbound/content/SBSpellCheck.xul", "_blank", params, false, true, true, args, "work_please");
}


