// vim: foldmethod=marker

flock.xpcom = {/*{{{*/
    // am i smart enough
    // cute enough
    // rich enough
    // tough enough?
}/*}}}*/

flock.xpcom.getService = function (aClass, aInterface) {/*{{{*/
    XXX('getService', aInterface);
    if (typeof aInterface == "string") {
        aInterface = Components.interfaces[aInterface];
    }
    return Components.classes[aClass].getService(aInterface);
}/*}}}*/
flock.xpcom.createInstance = function (aClass, aInterface) {/*{{{*/
    if (typeof aInterface == "string") {
        aInterface = Components.interfaces[aInterface];
    }
    return Components.classes[aClass].createInstance(aInterface);
}/*}}}*/


flock.xpcom.__defineGetter__('clipboard', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/widget/clipboard;1",
        "nsIClipboard"
    );
});/*}}}*/
flock.xpcom.__defineGetter__('windowMediator', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/appshell/window-mediator;1",
        "nsIWindowMediator"
    );
});/*}}}*/
flock.xpcom.__defineGetter__('xulSortService', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/xul/xul-sort-service;1",
        "nsIXULSortService"
    );
});/*}}}*/
flock.xpcom.__defineGetter__('observerService', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/observer-service;1",
        "nsIObserverService"
    );   
});/*}}}*/
flock.xpcom.__defineGetter__('accessibilityService', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/accessibilityService;1",
        "nsIAccessibilityService"
    );   
});/*}}}*/
flock.xpcom.__defineGetter__('formHistoryService', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/satchel/form-history;1",
        "nsIFormHistory"
    );   
});/*}}}*/
flock.xpcom.__defineGetter__('stringBundleService', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/intl/stringbundle;1",
        "nsIStringBundleService"
    );   
});/*}}}*/
flock.xpcom.__defineGetter__('ioService', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/network/io-service;1",
        "nsIIOService"
    );   
});/*}}}*/
flock.xpcom.__defineGetter__('dragService', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/widget/dragservice;1",
        "nsIDragService"
    );   
});/*}}}*/
flock.xpcom.__defineGetter__('prefService', function () {/*{{{*/
    return flock.xpcom.getService(
        "@mozilla.org/preferences-service;1",
        "nsIPrefService"
    );   
});/*}}}*/

// observer stuff
flock.xpcom.addObserver = function (aTopic, aObserver, aWeakRef) {/*{{{*/
    if (typeof aObserver == "function") {
        var observer = { observe: aObserver };
    }
    else {
        var observer = aObserver;
    }
    var weakref = aWeakRef || false;
    flock.xpcom.observerService.addObserver(observer, aTopic, weakref);
    return observer;
};/*}}}*/
flock.xpcom.notifyObservers = function (aTopic, aSubject, aData) {/*{{{*/
    var subject = aSubject;
    if (typeof subject == "string") {
        subject = new flock.xpcom.SupportsString(aSubject);
    }
    flock.xpcom.observerService.notifyObservers(subject, aTopic, aData);
};/*}}}*/
flock.xpcom.pingObservers = function (aSubject) {/*{{{*/
    flock.xpcom.observerService.notifyObservers(
        new flock.xpcom.SupportsString(),
        aSubject,
        null
    );
};/*}}}*/
flock.xpcom.removeObserver = function (aTopic, aObserver) {/*{{{*/
    flock.xpcom.observerService.removeObserver(aObserver, aTopic);
};/*}}}*/

// accessibility stuff
flock.xpcom.createAccessible = function (aType) {/*{{{*/
    var args = flock.lang.toArray(arguments);
    args.shift();
    return flock.xpcom.accessibilityService['create'+aType+'Accessible']
        .apply(this, args);
};/*}}}*/

// clipboard stuff
flock.xpcom.globalClipboard =
    Components.interfaces.nsIClipboard.kGlobalClipboard;
                             
flock.xpcom.setClipboardData = function (aTransferable, aClipboard) {/*{{{*/
    var whichClipboard = (aClipboard) ? 
        aClipboard : 
        flock.xpcom.globalClipboard;
    flock.xpcom.clearClipboardData(whichClipboard);
    flock.xpcom.clipboard.setData(
        aTransferable,    
        null,
        flock.xpcom.globalClipboard
    );
};/*}}}*/
flock.xpcom.clearClipboardData = function (aClipboard) {/*{{{*/
    var whichClipboard = (aClipboard) ? 
        aClipboard : 
        flock.xpcom.globalClipboard;
    flock.xpcom.clipboard.emptyClipboard(whichClipboard);
};/*}}}*/

// string bundle stuff
flock.xpcom.stringBundle = function (aChromeURL) {/*{{{*/
    return flock.xpcom.stringBundleService.createBundle(aChromeURL);
};/*}}}*/
flock.xpcom.stringBundler = function (aChromeURL) {/*{{{*/
    var bundle = flock.xpcom.stringBundle(aChromeURL);
    return function (aStr) {
        return bundle.GetStringFromName(aStr);
    };
};/*}}}*/

// drag service stuff
flock.xpcom.dragSession = function () {/*{{{*/
    return flock.xpcom.dragService.getCurrentSession();
}/*}}}*/

// base64 stuff
//XXX andy: we do not actually have a real xpcom service for
//          for this yet, but someday we will... i hope
//          for now this is just a hack to replicate such an interface
flock.xpcom.base64Service = {
    chars: 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=',
    encode: function (aInput) {/*{{{*/
        var output = '';
        while (aInput.length > 0) {
            output += flock.xpcom.base64Service.chars[aInput.charCodeAt(0) >> 2];
            output += flock.xpcom.base64Service.chars[((aInput.charCodeAt(0)&0x03) << 4) | 
                (aInput.length>1?((aInput.charCodeAt(1)&0xF0) >> 4):0)];
            output += flock.xpcom.base64Service.chars[aInput.length>1?
                ((aInput.charCodeAt(1)&0x0F)<<2) | 
                (aInput.length>2?((aInput.charCodeAt(2)&0xC0) >> 6):0):64];
            output += flock.xpcom.base64Service.chars[aInput.length>2?
                (aInput.charCodeAt(2)&0x3F):64];
            if (aInput.length > 3) {
                aInput = aInput.substr (3);
            } else {
                break;
            }
        }
        return output;
    },/*}}}*/
    decode: function (aInput) {/*{{{*/
        const regexp = new RegExp ('[^'+flock.xpcom.base64Service.chars+']', 'g');
        var output = '';

        aInput = aInput.replace (regexp, '');

        // FIXME: aInput MUST now be a multiple of four characters long

        function sixbits (i) {
            if (i == '=') return 0;
            return flock.xpcom.base64Service.chars.indexOf (i);
        }

        while (aInput.length >= 4) {
            output += String.fromCharCode ((sixbits (aInput[0]) << 2) | 
                    (sixbits (aInput[1]) >> 4));
            if (aInput[2] == '=') {
                break;
            }
            output += String.fromCharCode ((sixbits (aInput[1]) << 4) |
                    (sixbits (aInput[2]) >>2));
            if (aInput[3] == '=') {
                break;
            }
            output += String.fromCharCode (((sixbits (aInput[2]) << 6) & 0xC0) |
                    sixbits (aInput[3]));
            aInput = aInput.substr (4);
        }
        return output;
    },/*}}}*/
}



// xpcom base stuff
flock.xpcom.Supports = function (aOpts) {/*{{{*/
    // XXX andy: I would like to use adapters in this class
    flock.Base.call(this, aOpts);
    if (!this.interfaces) this.interfaces = [];
    this.interfaces.push(Components.interfaces.nsISupports);
    
    // convert string shortcuts implements to Components
    this.interfaces = this.interfaces.map(function (aVal) {
        var iface = aVal;
        if (typeof iface == "string") {
            iface = Components.interfaces[iface];
        }
        return iface;
    });
}/*}}}*/
dojo.inherits(flock.xpcom.Supports, flock.Base);
dojo.lang.extend(flock.xpcom.Supports, {
    interfaces: null,
    QueryInterface: function (aIID) {/*{{{*/
        for (var i = 0; i < this.interfaces.length; ++i) {
            var iface = this.interfaces[i];
            if (aIID.equals(iface)) return this;
        }
        throw Components.results.NS_ERROR_NO_INTERFACE;
    },/*}}}*/
});

flock.xpcom.Transferable = function (aData, aOpts) {/*{{{*/
    this._proxy = flock.xpcom.createInstance(
        '@mozilla.org/widget/transferable;1',
        'nsITransferable'
    );
    this.data = {};
    if (aData) {
        if ('toTransferData' in aData) {
            aData = aData.toTransferData();
        }
        for (var x in aData) {
            this.addData(x, aData[x]);
        }
    }
    flock.xpcom.Supports.call(this, aOpts);
    this.interfaces.push(Components.interfaces.nsITransferable);
};/*}}}*/
dojo.inherits(flock.xpcom.Transferable, flock.xpcom.Supports);
dojo.lang.extend(flock.xpcom.Transferable, {
    _proxy: null,
    data: null,
    get kFlavorHasDataProvider() { /*{{{*/
        return this._proxy.kFlavorHasDataProvider; 
    },/*}}}*/
    get converter() { return this._proxy.converter; },
    set converter(aVal) { return this._proxy.converter = aVal; },
    flavorsTransferableCanExport: function () {/*{{{*/
        return this._proxy.flavorsTransferableCanExport();
    },/*}}}*/
    flavorsTransferableCanImport: function () {/*{{{*/
        return this._proxy.flavorsTransferableCanImport();
    },/*}}}*/
    addDataFlavor: function (aFlav) {/*{{{*/
        if (aFlav in this.data) return;
        this.data[aFlav] = null;
        this._proxy.addDataFlavor(aFlav);
    },/*}}}*/
    getAnyTransferData: function (aFlav, aData, aLen) {/*{{{*/
        this._proxy.getAnyTransferData(aFlav, aData, aLen);
    },/*}}}*/
    getTransferData: function (aFlav, aData, aLen) {/*{{{*/
        this._proxy.getTransferData(aFlav, aData, aLen);
    },/*}}}*/
    isLargeDataSet: function () {/*{{{*/
        return this._proxy.isLargeDataSet();
    },/*}}}*/
    removeDataFlavor: function (aFlav) {/*{{{*/
        if (aFlav in this.data) {
            delete this.data[aFlav];
            this._proxy.removeDataFlavor(aFlav);
        }
    },/*}}}*/
    setTransferData: function (aFlav, aData, aLen) {/*{{{*/
        if (aFlav in this.data) {
            this.data[aFlav] = aData;
        }
        this._proxy.setTransferData(aFlav, aData, aLen);
    },/*}}}*/
    
    // XXX andy: totally stupid hack to support the screwed up
    //           built in TransferData object
    get dataList() {/*{{{*/
        var out = [];
        for (flav in this.data) {
            out.push(new FlavourData(this.data[flav], null,
                                     new Flavour(flav, null)));
        }
        return out;
    },/*}}}*/
    
    // niceness
    addData: function (aFlav, aData) {/*{{{*/
        this.addDataFlavor(aFlav);
        var data = ("string" == typeof aData) ? 
            new flock.xpcom.SupportsString(aData) :
            aData;
        var length = data.length;
        this.setTransferData(aFlav, data, length*2);   
    },/*}}}*/

});


flock.xpcom.Timer = function (aCallback, aDelay, aOpts) {
    this._proxy = flock.xpcom.createInstance(
        "@mozilla.org/timer;1",
        "nsITimer"
    );
    this.type = this.TYPE_ONE_SHOT;
    this.delay = aDelay;
    if (aCallback) {
        if (!aCallback.notify) {
            this.callback = {notify: aCallback};
        }
        else {
            this.callback = aCallback;
        }
    }   
    
    flock.xpcom.Supports.call(this, aOpts);
    this.interfaces.push(Components.interfaces.nsITimer);
    this.interfaces.push(Components.interfaces.nsITimerInternal);

    this.initWithCallback(this.callback, this.delay, this.type);
    this.idle = false;
}
dojo.inherits(flock.xpcom.Timer, flock.xpcom.Supports);
dojo.lang.extend(flock.xpcom.Timer, {
    TYPE_ONE_SHOT: 0,
    TYPE_REPEATING_SLACK: 1,
    TYPE_REPEATING_PRECISE: 2,
    _proxy: null,
    callback: null,
    get idle() { 
        this._proxy.QueryInterface(Components.interfaces.nsITimerInternal);
        return this._proxy.idle; 
    },
    set idle(aVal) { 
        this._proxy.QueryInterface(Components.interfaces.nsITimerInternal);
        this._proxy.idle = aVal; 
    },
    init: function (aObserver, aDelay, aType) {
        this._proxy.init(aObserver, aDelay, aType);
    },
    initWithCallback: function (aCallback, aDelay, aType) {
        this._proxy.initWithCallback(aCallback, aDelay, aType);
    },
    cancel: function () { this._proxy.cancel(); },
    
    // cool stuff
    bump: function (aDelay, aCallback) {
        this.cancel();
        if (aDelay != null) this.delay = aDelay;
        if (aCallback) {
            if (!aCallback.notify) { 
                this.callback = {notify: aCallback};
            }
            else { 
                this.callback = aCallback;
            }
        }
        this.initWithCallback(this.callback, this.delay, this.type);
    }
});







// XXX andy: FIXME
flock.xpcom.SupportsString = function (aStr, aOpts) {/*{{{*/
    this._proxy = flock.xpcom.createInstance(
        '@mozilla.org/supports-string;1',
        'nsISupportsString'
    );
    this._proxy.data = aStr;
    flock.Base.call(this, aOpts);
};/*}}}*/
dojo.inherits(flock.xpcom.SupportsString, flock.Base);
dojo.lang.extend(flock.xpcom.SupportsString, {
    _proxy: null,
    get length() { return this._proxy.data.length; },
    get data() { return this._proxy.data; },
    set data(aVal) { return this._proxy.data = aVal; },
    get type() { return this._proxy.type; },
    toString: function () { return this._proxy.toString() },
    QueryInterface: function () { return this._proxy.QueryInterface.apply(this._proxy, arguments); },
});

// XXX andy: FIXME
// Fakes the nsISimpleEnumerator to pass Javascript through it
flock.xpcom.JsSimpleEnumerator = function (aArr, aOpts) {/*{{{*/
    this.data = aArr;
    flock.xpcom.Supports.call(this, aOpts);
    this.interfaces.push(Components.interfaces.nsISimpleEnumerator);
}/*}}}*/
dojo.inherits(flock.xpcom.JsSimpleEnumerator, flock.xpcom.Supports);
dojo.lang.extend(flock.xpcom.JsSimpleEnumerator, {
    _idx: 0,
    hasMoreElements: function () {/*{{{*/
        return (this.data.length > this._idx);
    },/*}}}*/
    getNext: function () {/*{{{*/
        var item = this.data[this._idx];
        this._idx++;
        // make it look like an nsISupports
        return {
            QueryInterface: function () { 
                return this.data;    
            },   
            data: item,
        };
    }/*}}}*/
});
