// vim: foldmethod=marker
var gStarButtonClickHandler = new flock.xul.ClickSplitter(null, {
    onDblClick: function (aEvent) {/*{{{*/
        XXX('DOUBLE CLICK');
        flock.command('cmd_favoriteCreateCurrentDetailed');
    },/*}}}*/
});


// this should be added to the photobar api (load from url)
function loadPhotoBar () {
    var APIMGR = Components.classes['@flock.com/photo-api-manager;1?'] 
                           .getService(Components.interfaces.flockIPhotoAPIManager);

    var service = APIMGR.getAPIFromShortname(flock.browser.currentPhotos);
    service.getValidPerson({
        onGetValidPerson: function(aPerson) {
            var PPSVC = Components.classes['@mozilla.org/rdf/datasource;1?name=flock-people-photo']
                                  .getService(Components.interfaces.flockIPhotoPeopleService);
            PPSVC.addToRecent(aPerson);
            flock_topbarSelectById('flock_PhotoBrowseTopbarBroadcaster', true);
            if (TopbarJSCtx().photoBrowser) TopbarJSCtx().photoBrowser.loadPersonPre(aPerson);
        }
    }, flock.browser.currentUrl);
}

function savePhotoPerson() {
    var APIMGR = Components.classes['@flock.com/photo-api-manager;1?'] 
                           .getService(Components.interfaces.flockIPhotoAPIManager);

    var service = APIMGR.getAPIFromShortname(flock.browser.currentPhotos);
    service.getValidPerson({
        onGetValidPerson: function(aPerson) {
            const LIST_WATCHED = Components.interfaces.flockIPhotoPeopleService.LIST_WATCHED;
            var PPSVC = Components.classes['@mozilla.org/rdf/datasource;1?name=flock-people-photo']
                                  .getService(Components.interfaces.flockIPhotoPeopleService);

            if (!PPSVC.isInList(LIST_WATCHED, aPerson))
                PPSVC.addToList(LIST_WATCHED, aPerson);
        }
    }, flock.browser.currentUrl);
}

function superStar() {
  var documentUrl = flock.browser.currentUrl;
  var feeds = gWebProgressListener.verifiedFeeds[documentUrl];

  // make it a STAR
  flock.command('cmd_favoriteCreateCurrent');

  // then FEED it 

  feeds.forEach( 
    function (element, index, array) {
      if (!flock.feed.service.isSubscription(element.url)) {
        flock.feed.service.subscribeFeed( element.url , null, null, false );
      }
    });

  // then take its PHOTO

  if (flock.browser.currentPhotos) {
    savePhotoPerson();
  }

  // this is (not) LOVE
}

var gWebProgressListener = new flock.browser.WebProgressListener({
    mButton: null,
    currentUrl: null,
    discoveredFeeds: new Array(),
	verifiedFeeds: new Array(),
	newsSidebarTimer: Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer),
    
    updateCreateFromTabs: function() {/*{{{*/
        if (flock.browser.currentTabs.length > 1) {
           flock.xul.enable($('cmd_collectionCreateFromTabs'));
        }
        else {
           flock.xul.disable($('cmd_collectionCreateFromTabs'));
        }
    },/*}}}*/
    updateButton: function() {/*{{{*/
        updateStarState();
    },/*}}}*/
    updatePhotoButton: function () {/*{{{*/
        if (flock.browser.currentPhotos) {
            flock.xul.enable($('cmd_viewPhotoViewOptionsMenu'));
        } else {
            flock.xul.disable($('cmd_viewPhotoViewOptionsMenu'));
        }
    },/*}}}*/
    updateFeedButton: function() {/*{{{*/
    	dump("updateFeedButton: currentUrl: '" + this.currentUrl + "'\n");
      var localeService = Components.classes["@mozilla.org/intl/nslocaleservice;1"].getService(Components.interfaces.nsILocaleService);
      var stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
      var stringBundle = stringBundleService.createBundle("chrome://flock/locale/favorites/favorites.properties", localeService.getApplicationLocale());
        if(this.verifiedFeeds[this.currentUrl].length > 0) {
            flock.xul.enable($('cmd_viewFeedsViewOptionsMenu'));
            if (flock.browser.isFeedView) {
            	flock.xul.disable($('cmd_viewFeedsToggle'));
            } else {
            	flock.xul.enable($('cmd_viewFeedsToggle'));
            }
            if(this.verifiedFeeds[this.currentUrl].length == 1) {
            	var tooltip = stringBundle.GetStringFromName("flock.favorites.feeds.desc.1");
            } else {
            	var tooltip = stringBundle.GetStringFromName("flock.favorites.feeds.desc.1");
            }
            $('cmd_viewFeedsViewOptionsMenu').setAttribute("tooltiptext", tooltip);
            updateDiscoveredFeedsPopup();
        } else {
            flock.xul.disable($('cmd_viewFeedsViewOptionsMenu'));
            flock.xul.disable($('cmd_viewFeedsToggle'));
        }
    },/*}}}*/
    onNewLocation: function(aUrl) {/*{{{*/
    	dump("onNewLocation: url: " + aUrl + "\n");
    	this.currentUrl = aUrl;
    	if(!this.discoveredFeeds[this.currentUrl]) {
    		this.discoveredFeeds[this.currentUrl] = new Array();
			this.verifiedFeeds[this.currentUrl] = new Array();
		}
        this.updateCreateFromTabs();
        this.updateButton();
        this.updateFeedButton();
        this.updatePhotoButton();
        var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
		if (prefs.getBoolPref("flock.feeds.sidebar_tab_interaction", true)) {
	        if (aUrl.split(":")[0] == "feed" || aUrl.split(":")[0] == "feeds" || aUrl.split(":")[0] == "opml" || aUrl.match(/http:\/\/extensions.flock.com\/news/) || aUrl.match(/http:\/\/stage.flock.com\/news/)) {
	        	if(!$("flock_NewsSidebarBroadcaster").getAttribute("checked")) {
	        		var timerCallback = {
						notify: function(aTimer) { newsSidebarOpen(); }
					}
					this.newsSidebarTimer.cancel();
					this.newsSidebarTimer.initWithCallback(timerCallback, 250, this.newsSidebarTimer.TYPE_ONE_SHOT);
	        	}
	        } else {
	        	if($("flock_NewsSidebarBroadcaster").getAttribute("checked")) {
	        		var timerCallback = {
						notify: function(aTimer) { newsSidebarClose(); }
					}
					this.newsSidebarTimer.cancel();
					this.newsSidebarTimer.initWithCallback(timerCallback, 250, this.newsSidebarTimer.TYPE_ONE_SHOT);
	        	}
	        }
		}
    },/*}}}*/
    onStopLoad: function() {/*{{{*/
    	dump("gWebProgressListener: onStopLoad\n");
        this.updatePhotoButton();
        // this really does not need to be called all that often
        if (flock.browser.currentFeeds) {
            if (flock.favorites.isFavorite(flock.browser.currentUrl)) {
                //flock.favorites.updateFeedsForFavorite(flock.browser.currentFeeds, flock.browser.currentUrl);
            }
        }
    },/*}}}*/
    onStartLoad: function(aRequest) {/*{{{*/
		if(aRequest) {
	    	var url = aRequest.name;
			dump("onStartLoad: url: '" + url + "'\n");
			this.discoveredFeeds[url] = new Array();
			this.verifiedFeeds[url] = new Array();
		}
    }/*}}}*/
});

function updateStarState() {
  var isFav = flock.favorites.isFavorite(
    flock.browser.currentUrl
  );

  starButton.setAttribute("state", (isFav ? 'on' : 'off'));
}

var starButton = null;
var favoritesObserver = null;
var favoritesSharingObserver = null;

// this is likely to be yanked out for sharing
function onLoad_favoritesOverlay() {
    starButton = $('favoritesButton');
    gStarButtonClickHandler.mNode = starButton;

    // make an observer for the starbutton to watch for updates on
    favoritesObserver = flock.xpcom.addObserver('favorites', function (aSubject, aTopic) {
        updateStarState();
    });
    favoritesSharingObserver = flock.xpcom.addObserver('favorites-sharing', function (aSubject, aTopic) {
        openFlockPreferences('paneFavorites');
        gBrowser.hideMessage(gBrowser.selectedBrowser, "top");
    });

    // our general purpose web progress listener, apparently
	gWebProgressListener.mButton = starButton;

    window.getBrowser().addProgressListener(gWebProgressListener, Components.interfaces.nsIWebProgressListener);
    
    // listen for LINK tags and update the feed subscription button
    window.getBrowser().addEventListener("DOMLinkAdded", function (aEvt) {
		var element = aEvt.target;
		var documentUrl = element.ownerDocument.URL;
		if(element.localName == "LINK" && element.rel == "alternate") {
			if (element.type == "application/rss+xml" 
                || element.type == "application/atom+xml" 
                || element.type == "text/xml") {
				dump("DOMLinkAdded: discovered feed: url: " + element.href + "\n");
				var flockFeedPrioritizeListener = {
					url: documentUrl,
					onComplete: function(len, array) {
						if (len == 1) {
							dump("DOMLinkAdded: verified feed: url: " + array[0]["url"] + " title: " + array[0]["title"] + " type: " + array[0]["type"] + "\n");
							var verifiedFeeds = gWebProgressListener.verifiedFeeds[this.url];
							function mapType(type) {
								switch (type) {
									case "Atom 1.0": return 5; break;
									case "Atom 0.3": return 4; break;
									case "RSS 2.0": return 3; break;
									case "RSS 1.0": return 2; break;
									default: return 1; break;
								}
							}
							for (var c = 0; c < verifiedFeeds.length; c++) {
								if (verifiedFeeds[c]["title"] == array[0]["title"] && verifiedFeeds[c]["type"] != array[0]["type"]) {
									if (mapType(array[0]["type"]) > mapType(verifiedFeeds[c]["type"])) {
										verifiedFeeds[c] = array[0];
									}
									array = null;
								}
							}
							if (array) {
								gWebProgressListener.verifiedFeeds[this.url].push(array[0]);
							}
					        gWebProgressListener.updateFeedButton();
						}
					}
				}
				if (!gWebProgressListener.discoveredFeeds[documentUrl]) {
					gWebProgressListener.discoveredFeeds[documentUrl] = new Array();
					gWebProgressListener.verifiedFeeds[documentUrl] = new Array();
				}
				if (!(element.href in gWebProgressListener.discoveredFeeds[documentUrl])) {
					gWebProgressListener.discoveredFeeds[documentUrl][element.href] = {title: element.title, type: element.type};
					flock.feed.service.prioritizeFeeds(1, [element.href], flockFeedPrioritizeListener);	
				}
			}
		}
    }, false);
    
};

function updateStarButtonPopup( popup ) {
  var localeService = Components.classes["@mozilla.org/intl/nslocaleservice;1"].getService(Components.interfaces.nsILocaleService);
  var stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
  var stringBundle = stringBundleService.createBundle("chrome://flock/locale/favorites/favorites.properties", localeService.getApplicationLocale());
  var kids = popup.childNodes;
  for (var i=kids.length-1; i>=0; i--) {
    if (!(kids[i].getAttribute('dontDelete')))
      popup.removeChild(kids[i]);
  }

  var documentUrl = flock.browser.currentUrl;
  var feeds = gWebProgressListener.verifiedFeeds[documentUrl];
  var superstar = false;
  var collections;

  if (feeds.length > 0) {
    collections = flock.feed.service.getCollections({});
  }

  feeds.forEach( 
    function (element, index, array) {
      if (flock.feed.service.isSubscription(element.url)) {
        var v = document.createElement('menuitem');
        popup.appendChild( v );
        v.label = stringBundle.GetStringFromName("flock.favorites.subscribedTo2").replace('%1',element.title);
        v.setAttribute('disabled', 'true');
      } else {
        superstar = true;
        if (collections.length == 0) {
          var v = document.createElement('menuitem');
          popup.appendChild( v );
          v.label = stringBundle.GetStringFromName("flock.favorites.subscribeTo2").replace('%1',element.title);
          v.setAttribute('oncommand', "flock.feed.service.subscribeFeed('" + element.url +"', null, null, false); event.preventBubble();");
        } else {
          var v = $('feedTemplate').cloneNode(true);
          v.label = stringBundle.GetStringFromName("flock.favorites.subscribeTo2").replace('%1',element.title);
          popup.appendChild( v );
          v.removeAttribute("hidden");
          v.removeAttribute("dontDelete");

          var collectionPopup  = v.firstChild;

          for (var i=0; i<collections.length; i++) {
            var collection = collections[i];
            var collectionItem = document.createElement('menuitem');
            collectionItem.setAttribute('label', collection.title );
            collectionPopup.appendChild( collectionItem );
            collectionItem.setAttribute('oncommand', "flock.feed.service.subscribeFeed('" + element.url +"', '" + collection.urn + "', flock.feed.service.ORIENT_INSIDE, false ); event.preventBubble();");
          }
          v.setAttribute("label", stringBundle.GetStringFromName("flock.favorites.subscribeTo3").replace('%1',element.title));
        }
      }
    });

  if (flock.browser.currentPhotos) {
    v = document.createElement('menuitem');
    popup.appendChild( v );
    v.label = stringBundle.GetStringFromName("flock.favorites.addPhotoStream");
    v.setAttribute('onclick', "savePhotoPerson()");
    superstar = true;
  }

  if (superstar) {
    v = document.createElement('menuseparator');
    popup.appendChild( v );
    v = document.createElement('menuitem');
    popup.appendChild( v );
    v.label = stringBundle.GetStringFromName("flock.favorites.superStar");
    v.setAttribute('onclick', "superStar()");
  }

  var isFav = flock.favorites.isFavorite(
    flock.browser.currentUrl
  );        
  if (isFav) {
    $('favoriteCreateCurrent').setAttribute('hidden','true');
    $('favoriteRemoveCurrent').removeAttribute('hidden');
  } else {
    $('favoriteCreateCurrent').removeAttribute('hidden');
    $('favoriteRemoveCurrent').setAttribute('hidden','true');
  }
}

function onUnload_favoritesOverlay() {
    flock.xpcom.removeObserver( 'favorites', favoritesObserver );
    flock.xpcom.removeObserver( 'favorites-sharing', favoritesSharingObserver );
}

window.addEventListener("load", onLoad_favoritesOverlay, false);
window.addEventListener("unload", onUnload_favoritesOverlay, false);

