var feedServiceListener = {
	onChanged: function() {
		var unread = flock.feed.service.getTotalUnreadCount();
		var localeService = Components.classes["@mozilla.org/intl/nslocaleservice;1"].getService(Components.interfaces.nsILocaleService);
		var stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
		var strBundle = stringBundleService.createBundle("chrome://flock/locale/feed/feed.properties", localeService.getApplicationLocale());
		if (unread > 0) {
			if (unread == 1) {
				var tooltip = strBundle.GetStringFromName("flock.feed.tooltip1");
			} else {
				var tooltip = strBundle.GetStringFromName("flock.feed.tooltip2").replace('%1', unread);
			}
		} else {
			var tooltip = strBundle.GetStringFromName("flock.feed.tooltip3");
		}
		try {
			$("flock_NewsSidebarBroadcaster").setAttribute("tooltiptext", tooltip);
        } catch (e) { dd(e); }
	},
	
	onNewCountUpdate: function(itemCount) {
		dump("onNewCountUpdate: count: " + itemCount + "\n");
		if (itemCount > 0) {
			$("flock_NewsSidebarBroadcaster").setAttribute("newitems", true);
		} else {
			$("flock_NewsSidebarBroadcaster").removeAttribute("newitems");
		}
	}
}

var newsDNDObserver = {

    onDragOver: function(aEvent, aFlavor, aSession) {
        dump("newsDNDObserver: onDragOver\n");
    },
    
    onDragEnter: function(aEvent, aSession) {
        dump("newsDNDObserver: onDragEnter\n");
    },
    
    onDragExit: function(aEvent, aSession) {
        dump("newsDNDObserver: onDragExit\n");
    },

	onDragStart: function(event, transferData, action) {
		var index = subscriptionTree.view.selection.currentIndex;
		if(index != -1) {
			var id = subscriptionTree.builder.getResourceAtIndex(index).ValueUTF8;
			var title = subscriptionTree.view.getCellText(index, subscriptionTree.columns.getNamedColumn("title"));
			var type = subscriptionTree.view.getCellText(index, subscriptionTree.columns.getNamedColumn("type"));
		} else {
			return;
		}
		transferData.data = new TransferData();
		transferData.data.addDataForFlavour("moz/rdfitem", id);
	},
	
	onDrop: function(aEvent, aDropData, aSession) {
		dump("newsDNDObserver: onDrop: contentType: " + aDropData.flavour.contentType + " data: " + aDropData.data + "\n");
		switch(aDropData.flavour.contentType) {
			case "application/x-moz-file":
				var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
				var fileHandler = ios.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
				var url = fileHandler.getURLSpecFromFile(aDropData.data);
				break;
			case "text/x-moz-url":
				var url = aDropData.data.split("\n")[0];
				break;
		}
		var feedService = Components.classes["@flock.com/feed-service;1"].getService(Components.interfaces.flockIFeedService);
		feedService.subscribeFeed(url, null, null, false);
	},
	
	getSupportedFlavours: function() {
		var flavors = new FlavourSet();
		flavors.appendFlavour("application/x-moz-file", "nsIFile");
		flavors.appendFlavour("text/x-moz-url");
		return flavors;
	}
	
}

var newsReadingTab;

function toggleNewsSidebar() {
	var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
	if (prefs.getBoolPref("flock.feeds.sidebar_tab_interaction", true)) {
	    try {
			var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
			var recentWindow = windowManager.getMostRecentWindow("navigator:browser");
			var contentBrowser = recentWindow.document.getElementById('content');
			if($("flock_NewsSidebarBroadcaster").getAttribute("checked")) {
				if(newsReadingTab && newsReadingTab.parentNode && contentBrowser.getBrowserForTab(newsReadingTab).currentURI.scheme == "feeds") {
					contentBrowser.removeTab(newsReadingTab);
				}
				newsSidebarClose();
			} else {
				if((!newsReadingTab || !newsReadingTab.parentNode || contentBrowser.getBrowserForTab(newsReadingTab).currentURI.scheme != "feeds") && (contentBrowser.currentURI.scheme != "feeds" && contentBrowser.currentURI.scheme != "feed")) {
					newsReadingTab = contentBrowser.addTab();
				}
				contentBrowser.selectedTab = newsReadingTab;	
				newsSidebarOpen();
			}
	    } catch (e) { dd(e); }
	} else {
		toggleSidebar('flock_NewsSidebarBroadcaster');
	}
}

function newsSidebarClose() {
	if($("flock_NewsSidebarBroadcaster").getAttribute("checked")) {
		toggleSidebar('flock_NewsSidebarBroadcaster');
	}
}

function newsSidebarOpen() {
	if(!$("flock_NewsSidebarBroadcaster").getAttribute("checked")) {
		toggleSidebar('flock_NewsSidebarBroadcaster');
	}
}

function contentSniffer(e) {
	try {
	
		var browser = window.getBrowser();
		var uri = e.originalTarget.documentURI;
		
		if (e.originalTarget instanceof XMLDocument) {
			var dataXML = e.originalTarget;
			var documentElement = dataXML.documentElement;
			var xmlns = documentElement.getAttribute("xmlns");
			var nodeName = documentElement.nodeName;
			
			if ((xmlns != null && (xmlns.toLowerCase() == "http://purl.org/rss/1.0/" || xmlns.toLowerCase() == "http://my.netscape.com/rdf/simple/0.9/" || xmlns.toLowerCase() == "http://purl.org/atom/ns#"))
				|| (nodeName != null && nodeName.toLowerCase() == "rss")) {
				browser.loadURIWithFlags("feeds:" + encodeURIComponent(uri), browser.LOAD_FLAGS_REPLACE_HISTORY);
			} else if (nodeName != null && nodeName.toLowerCase() == "opml") {
				browser.loadURIWithFlags("opml:" + encodeURIComponent(uri), browser.LOAD_FLAGS_REPLACE_HISTORY);
			}
		}

	} catch (e) {}
}

function feedsInit(e) {
	feedServiceListener.onChanged();
	feedServiceListener.onNewCountUpdate(flock.feed.service.getNewCount());
	flock.feed.service.addObserver(feedServiceListener);
}

function feedsClose() {
	flock.feed.service.removeObserver(feedServiceListener);
}

window.addEventListener("load", feedsInit, false);
window.addEventListener("unload", feedsClose, false);

window.addEventListener("load", contentSniffer, true);
